<script>
    import {onMount} from "svelte";
    import {cars} from "../stores";
    import EditCar from "../components/EditCar.svelte";
    import {getCars, deleteCar} from "../CarStore";

    let currentCar = {};

    onMount(async () => {
        await getCars();
    });

    let sortBy = {col: "name", ascending: true};

    $: sort = (column) => {

        if (sortBy.col == column) {
            sortBy.ascending = !sortBy.ascending
        } else {
            sortBy.col = column
            sortBy.ascending = true
        }

        // Modifier to sorting function for ascending or descending
        let sortModifier = (sortBy.ascending) ? 1 : -1;

        let sort = (a, b) =>
            (a[column] < b[column])
                ? -1 * sortModifier
                : (a[column] > b[column])
                    ? 1 * sortModifier
                    : 0;

        $cars = $cars.sort(sort);
    }

</script>

<h1>Cars</h1>
<!-- #key updates component when currentCar changes-->
{#key currentCar}
<EditCar car = {currentCar}/>
    {/key}
<table>
    <tr>
        <th on:click={sort("name")}>Model</th>
        <th on:click={sort("size")}>Size</th>
        <th on:click={sort("dailyRent")}>Price</th>
        <th></th>
        <th></th>
    </tr>
    {#each $cars as car}
        <tr>
            <td>{car.name}</td>
            <td>{car.size}</td>
            <td>{car.dailyRent}</td>
            <td><button on:click={() => currentCar = car}>Edit</button></td>
            <td><button class="negative" on:click={() => confirm("Yes/no?") ? deleteCar(car.id) : null}>Delete</button></td>
        </tr>
    {/each}
</table>